% Demo script for estimation of Eigenfaces in face recognition
% Allen Yang, 2008. UC Berkeley

clear;
close all;

load subjectOneMatrix.mat
imageX = 192/3; 
imageY = 168/3;

% Render one image as example
figure(1);
faceImage = reshape(subjectOneMatrix(:,1),[imageX imageY]);
faceImage = mat2gray(faceImage);
imshow(faceImage);

% SVD
[U, S, V] = svd(subjectOneMatrix);

R = U(:,1:4); % Pick 4-D eigen feature space

% Render Eigenfaces
figure(2);
for plotIndex=1:4
    subplot(1,4,plotIndex);
    faceImage = floor(255*reshape(R(:,plotIndex),[imageX imageY]));
    faceImage = mat2gray(faceImage);
    imshow(faceImage);
end