% Demo script for Nearest Neighbor algorithm
% Allen Yang, 2008. UC Berkeley

clear;
close all;

% First, randomly generate three classes in R2.
samplePerClass = 5;
classCount = 3;

dataMatrix = rand(2,samplePerClass*classCount);
aprioriLabels = [ones(1,samplePerClass) 2*ones(1,samplePerClass) 3*ones(1,samplePerClass)];

figure(1); hold on
plot(dataMatrix(1,1:samplePerClass),dataMatrix(2,1:samplePerClass),'rd', 'MarkerSize',8);
plot(dataMatrix(1,samplePerClass+1:2*samplePerClass),dataMatrix(2,samplePerClass+1:2*samplePerClass),'b+','MarkerSize',8);
plot(dataMatrix(1,2*samplePerClass+1:3*samplePerClass),dataMatrix(2,2*samplePerClass+1:3*samplePerClass),'k*','MarkerSize',8);
set(gcf,'Color','White');

% Generate a random test vector
testVector = rand(2,1);
plot(testVector(1), testVector(2),'g.','MarkerSize',8);

% Compute distance measure
for sampleIndex=1:samplePerClass*classCount
    distanceArray(sampleIndex) = norm(dataMatrix(:,sampleIndex) - testVector);
end

[minDistance minIndex]= min(distanceArray);

aprioriLabels(minIndex)
arrow(testVector, dataMatrix(:,minIndex));